*---------------------------------------------------------------------*
*    view related FORM routines
*---------------------------------------------------------------------*
*...processing: YDDG_BRACKETS_MV................................*
FORM GET_DATA_YDDG_BRACKETS_MV.
  PERFORM VIM_FILL_WHERETAB.
*.read data from database.............................................*
  REFRESH TOTAL.
  CLEAR   TOTAL.
  SELECT * FROM YDDG_BRACKETS WHERE
(VIM_WHERETAB) .
    CLEAR YDDG_BRACKETS_MV .
YDDG_BRACKETS_MV-HANDLE =
YDDG_BRACKETS-HANDLE .
YDDG_BRACKETS_MV-DESCRIPTION =
YDDG_BRACKETS-DESCRIPTION .
<VIM_TOTAL_STRUC> = YDDG_BRACKETS_MV.
    APPEND TOTAL.
  ENDSELECT.
  SORT TOTAL BY <VIM_XTOTAL_KEY>.
  <STATUS>-ALR_SORTED = 'R'.
*.check dynamic selectoptions (not in DDIC)...........................*
  IF X_HEADER-SELECTION NE SPACE.
    PERFORM CHECK_DYNAMIC_SELECT_OPTIONS.
  ELSEIF X_HEADER-DELMDTFLAG NE SPACE.
    PERFORM BUILD_MAINKEY_TAB.
  ENDIF.
  REFRESH EXTRACT.
ENDFORM.
*---------------------------------------------------------------------*
FORM DB_UPD_YDDG_BRACKETS_MV .
*.process data base updates/inserts/deletes.........................*
LOOP AT TOTAL.
  CHECK <ACTION> NE ORIGINAL.
MOVE <VIM_TOTAL_STRUC> TO YDDG_BRACKETS_MV.
  IF <ACTION> = UPDATE_GELOESCHT.
    <ACTION> = GELOESCHT.
  ENDIF.
  CASE <ACTION>.
   WHEN NEUER_GELOESCHT.
IF STATUS_YDDG_BRACKETS_MV-ST_DELETE EQ GELOESCHT.
     READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY>.
     IF SY-SUBRC EQ 0.
       DELETE EXTRACT INDEX SY-TABIX.
     ENDIF.
    ENDIF.
    DELETE TOTAL.
    IF X_HEADER-DELMDTFLAG NE SPACE.
      PERFORM DELETE_FROM_MAINKEY_TAB.
    ENDIF.
   WHEN GELOESCHT.
  SELECT SINGLE FOR UPDATE * FROM YDDG_BRACKETS WHERE
  HANDLE = YDDG_BRACKETS_MV-HANDLE .
    IF SY-SUBRC = 0.
    DELETE YDDG_BRACKETS .
    ENDIF.
    IF STATUS-DELETE EQ GELOESCHT.
      READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY> BINARY SEARCH.
      DELETE EXTRACT INDEX SY-TABIX.
    ENDIF.
    DELETE TOTAL.
    IF X_HEADER-DELMDTFLAG NE SPACE.
      PERFORM DELETE_FROM_MAINKEY_TAB.
    ENDIF.
   WHEN OTHERS.
  SELECT SINGLE FOR UPDATE * FROM YDDG_BRACKETS WHERE
  HANDLE = YDDG_BRACKETS_MV-HANDLE .
    IF SY-SUBRC <> 0.   "insert preprocessing: init WA
      CLEAR YDDG_BRACKETS.
    ENDIF.
YDDG_BRACKETS-HANDLE =
YDDG_BRACKETS_MV-HANDLE .
YDDG_BRACKETS-DESCRIPTION =
YDDG_BRACKETS_MV-DESCRIPTION .
    IF SY-SUBRC = 0.
    UPDATE YDDG_BRACKETS ##WARN_OK.
    ELSE.
    INSERT YDDG_BRACKETS .
    ENDIF.
    READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY>.
    IF SY-SUBRC EQ 0.
      <XACT> = ORIGINAL.
      MODIFY EXTRACT INDEX SY-TABIX.
    ENDIF.
    <ACTION> = ORIGINAL.
    MODIFY TOTAL.
  ENDCASE.
ENDLOOP.
CLEAR: STATUS_YDDG_BRACKETS_MV-UPD_FLAG,
STATUS_YDDG_BRACKETS_MV-UPD_CHECKD.
MESSAGE S018(SV).
ENDFORM.
*---------------------------------------------------------------------*
FORM READ_SINGLE_YDDG_BRACKETS_MV.
  SELECT SINGLE * FROM YDDG_BRACKETS WHERE
HANDLE = YDDG_BRACKETS_MV-HANDLE .
YDDG_BRACKETS_MV-HANDLE =
YDDG_BRACKETS-HANDLE .
YDDG_BRACKETS_MV-DESCRIPTION =
YDDG_BRACKETS-DESCRIPTION .
ENDFORM.
*---------------------------------------------------------------------*
FORM CORR_MAINT_YDDG_BRACKETS_MV USING VALUE(CM_ACTION) RC.
  DATA: RETCODE LIKE SY-SUBRC, COUNT TYPE I, TRSP_KEYLEN TYPE SYFLENG.
  FIELD-SYMBOLS: <TAB_KEY_X> TYPE X.
  CLEAR RC.
MOVE YDDG_BRACKETS_MV-HANDLE TO
YDDG_BRACKETS-HANDLE .
  CORR_KEYTAB             =  E071K.
  CORR_KEYTAB-OBJNAME     = 'YDDG_BRACKETS'.
  IF NOT <vim_corr_keyx> IS ASSIGNED.
    ASSIGN CORR_KEYTAB-TABKEY TO <vim_corr_keyx> CASTING.
  ENDIF.
  ASSIGN YDDG_BRACKETS TO <TAB_KEY_X> CASTING.
  PERFORM VIM_GET_TRSPKEYLEN
    USING 'YDDG_BRACKETS'
    CHANGING TRSP_KEYLEN.
  <VIM_CORR_KEYX>(TRSP_KEYLEN) = <TAB_KEY_X>(TRSP_KEYLEN).
  PERFORM UPDATE_CORR_KEYTAB USING CM_ACTION RETCODE.
  ADD: RETCODE TO RC, 1 TO COUNT.
  IF RC LT COUNT AND CM_ACTION NE PRUEFEN.
    CLEAR RC.
  ENDIF.

ENDFORM.
*---------------------------------------------------------------------*
*...processing: YDDG_BRACKETTRMV................................*
FORM GET_DATA_YDDG_BRACKETTRMV.
  PERFORM VIM_FILL_WHERETAB.
*.read data from database.............................................*
  REFRESH TOTAL.
  CLEAR   TOTAL.
  SELECT * FROM YDDG_BRACKET_THR WHERE
(VIM_WHERETAB) .
    CLEAR YDDG_BRACKETTRMV .
YDDG_BRACKETTRMV-HANDLE =
YDDG_BRACKET_THR-HANDLE .
YDDG_BRACKETTRMV-SECS =
YDDG_BRACKET_THR-SECS .
YDDG_BRACKETTRMV-TAG =
YDDG_BRACKET_THR-TAG .
<VIM_TOTAL_STRUC> = YDDG_BRACKETTRMV.
    APPEND TOTAL.
  ENDSELECT.
  SORT TOTAL BY <VIM_XTOTAL_KEY>.
  <STATUS>-ALR_SORTED = 'R'.
*.check dynamic selectoptions (not in DDIC)...........................*
  IF X_HEADER-SELECTION NE SPACE.
    PERFORM CHECK_DYNAMIC_SELECT_OPTIONS.
  ELSEIF X_HEADER-DELMDTFLAG NE SPACE.
    PERFORM BUILD_MAINKEY_TAB.
  ENDIF.
  REFRESH EXTRACT.
ENDFORM.
*---------------------------------------------------------------------*
FORM DB_UPD_YDDG_BRACKETTRMV .
*.process data base updates/inserts/deletes.........................*
LOOP AT TOTAL.
  CHECK <ACTION> NE ORIGINAL.
MOVE <VIM_TOTAL_STRUC> TO YDDG_BRACKETTRMV.
  IF <ACTION> = UPDATE_GELOESCHT.
    <ACTION> = GELOESCHT.
  ENDIF.
  CASE <ACTION>.
   WHEN NEUER_GELOESCHT.
IF STATUS_YDDG_BRACKETTRMV-ST_DELETE EQ GELOESCHT.
     READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY>.
     IF SY-SUBRC EQ 0.
       DELETE EXTRACT INDEX SY-TABIX.
     ENDIF.
    ENDIF.
    DELETE TOTAL.
    IF X_HEADER-DELMDTFLAG NE SPACE.
      PERFORM DELETE_FROM_MAINKEY_TAB.
    ENDIF.
   WHEN GELOESCHT.
  SELECT SINGLE FOR UPDATE * FROM YDDG_BRACKET_THR WHERE
  HANDLE = YDDG_BRACKETTRMV-HANDLE AND
  SECS = YDDG_BRACKETTRMV-SECS .
    IF SY-SUBRC = 0.
    DELETE YDDG_BRACKET_THR .
    ENDIF.
    IF STATUS-DELETE EQ GELOESCHT.
      READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY> BINARY SEARCH.
      DELETE EXTRACT INDEX SY-TABIX.
    ENDIF.
    DELETE TOTAL.
    IF X_HEADER-DELMDTFLAG NE SPACE.
      PERFORM DELETE_FROM_MAINKEY_TAB.
    ENDIF.
   WHEN OTHERS.
  SELECT SINGLE FOR UPDATE * FROM YDDG_BRACKET_THR WHERE
  HANDLE = YDDG_BRACKETTRMV-HANDLE AND
  SECS = YDDG_BRACKETTRMV-SECS .
    IF SY-SUBRC <> 0.   "insert preprocessing: init WA
      CLEAR YDDG_BRACKET_THR.
    ENDIF.
YDDG_BRACKET_THR-HANDLE =
YDDG_BRACKETTRMV-HANDLE .
YDDG_BRACKET_THR-SECS =
YDDG_BRACKETTRMV-SECS .
YDDG_BRACKET_THR-TAG =
YDDG_BRACKETTRMV-TAG .
    IF SY-SUBRC = 0.
    UPDATE YDDG_BRACKET_THR ##WARN_OK.
    ELSE.
    INSERT YDDG_BRACKET_THR .
    ENDIF.
    READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY>.
    IF SY-SUBRC EQ 0.
      <XACT> = ORIGINAL.
      MODIFY EXTRACT INDEX SY-TABIX.
    ENDIF.
    <ACTION> = ORIGINAL.
    MODIFY TOTAL.
  ENDCASE.
ENDLOOP.
CLEAR: STATUS_YDDG_BRACKETTRMV-UPD_FLAG,
STATUS_YDDG_BRACKETTRMV-UPD_CHECKD.
MESSAGE S018(SV).
ENDFORM.
*---------------------------------------------------------------------*
FORM READ_SINGLE_YDDG_BRACKETTRMV.
  SELECT SINGLE * FROM YDDG_BRACKET_THR WHERE
HANDLE = YDDG_BRACKETTRMV-HANDLE AND
SECS = YDDG_BRACKETTRMV-SECS .
YDDG_BRACKETTRMV-HANDLE =
YDDG_BRACKET_THR-HANDLE .
YDDG_BRACKETTRMV-SECS =
YDDG_BRACKET_THR-SECS .
YDDG_BRACKETTRMV-TAG =
YDDG_BRACKET_THR-TAG .
ENDFORM.
*---------------------------------------------------------------------*
FORM CORR_MAINT_YDDG_BRACKETTRMV USING VALUE(CM_ACTION) RC.
  DATA: RETCODE LIKE SY-SUBRC, COUNT TYPE I, TRSP_KEYLEN TYPE SYFLENG.
  FIELD-SYMBOLS: <TAB_KEY_X> TYPE X.
  CLEAR RC.
MOVE YDDG_BRACKETTRMV-HANDLE TO
YDDG_BRACKET_THR-HANDLE .
MOVE YDDG_BRACKETTRMV-SECS TO
YDDG_BRACKET_THR-SECS .
  CORR_KEYTAB             =  E071K.
  CORR_KEYTAB-OBJNAME     = 'YDDG_BRACKET_THR'.
  IF NOT <vim_corr_keyx> IS ASSIGNED.
    ASSIGN CORR_KEYTAB-TABKEY TO <vim_corr_keyx> CASTING.
  ENDIF.
  ASSIGN YDDG_BRACKET_THR TO <TAB_KEY_X> CASTING.
  PERFORM VIM_GET_TRSPKEYLEN
    USING 'YDDG_BRACKET_THR'
    CHANGING TRSP_KEYLEN.
  <VIM_CORR_KEYX>(TRSP_KEYLEN) = <TAB_KEY_X>(TRSP_KEYLEN).
  PERFORM UPDATE_CORR_KEYTAB USING CM_ACTION RETCODE.
  ADD: RETCODE TO RC, 1 TO COUNT.
  IF RC LT COUNT AND CM_ACTION NE PRUEFEN.
    CLEAR RC.
  ENDIF.

ENDFORM.
*---------------------------------------------------------------------*
*...processing: YDDG_CONFIG___MV................................*
FORM GET_DATA_YDDG_CONFIG___MV.
  PERFORM VIM_FILL_WHERETAB.
*.read data from database.............................................*
  REFRESH TOTAL.
  CLEAR   TOTAL.
  SELECT * FROM YDDG_CONFIG WHERE
(VIM_WHERETAB) .
    CLEAR YDDG_CONFIG___MV .
YDDG_CONFIG___MV-HANDLE =
YDDG_CONFIG-HANDLE .
YDDG_CONFIG___MV-VALUE =
YDDG_CONFIG-VALUE .
<VIM_TOTAL_STRUC> = YDDG_CONFIG___MV.
    APPEND TOTAL.
  ENDSELECT.
  SORT TOTAL BY <VIM_XTOTAL_KEY>.
  <STATUS>-ALR_SORTED = 'R'.
*.check dynamic selectoptions (not in DDIC)...........................*
  IF X_HEADER-SELECTION NE SPACE.
    PERFORM CHECK_DYNAMIC_SELECT_OPTIONS.
  ELSEIF X_HEADER-DELMDTFLAG NE SPACE.
    PERFORM BUILD_MAINKEY_TAB.
  ENDIF.
  REFRESH EXTRACT.
ENDFORM.
*---------------------------------------------------------------------*
FORM DB_UPD_YDDG_CONFIG___MV .
*.process data base updates/inserts/deletes.........................*
LOOP AT TOTAL.
  CHECK <ACTION> NE ORIGINAL.
MOVE <VIM_TOTAL_STRUC> TO YDDG_CONFIG___MV.
  IF <ACTION> = UPDATE_GELOESCHT.
    <ACTION> = GELOESCHT.
  ENDIF.
  CASE <ACTION>.
   WHEN NEUER_GELOESCHT.
IF STATUS_YDDG_CONFIG___MV-ST_DELETE EQ GELOESCHT.
     READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY>.
     IF SY-SUBRC EQ 0.
       DELETE EXTRACT INDEX SY-TABIX.
     ENDIF.
    ENDIF.
    DELETE TOTAL.
    IF X_HEADER-DELMDTFLAG NE SPACE.
      PERFORM DELETE_FROM_MAINKEY_TAB.
    ENDIF.
   WHEN GELOESCHT.
  SELECT SINGLE FOR UPDATE * FROM YDDG_CONFIG WHERE
  HANDLE = YDDG_CONFIG___MV-HANDLE .
    IF SY-SUBRC = 0.
    DELETE YDDG_CONFIG .
    ENDIF.
    IF STATUS-DELETE EQ GELOESCHT.
      READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY> BINARY SEARCH.
      DELETE EXTRACT INDEX SY-TABIX.
    ENDIF.
    DELETE TOTAL.
    IF X_HEADER-DELMDTFLAG NE SPACE.
      PERFORM DELETE_FROM_MAINKEY_TAB.
    ENDIF.
   WHEN OTHERS.
  SELECT SINGLE FOR UPDATE * FROM YDDG_CONFIG WHERE
  HANDLE = YDDG_CONFIG___MV-HANDLE .
    IF SY-SUBRC <> 0.   "insert preprocessing: init WA
      CLEAR YDDG_CONFIG.
    ENDIF.
YDDG_CONFIG-HANDLE =
YDDG_CONFIG___MV-HANDLE .
YDDG_CONFIG-VALUE =
YDDG_CONFIG___MV-VALUE .
    IF SY-SUBRC = 0.
    UPDATE YDDG_CONFIG ##WARN_OK.
    ELSE.
    INSERT YDDG_CONFIG .
    ENDIF.
    READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY>.
    IF SY-SUBRC EQ 0.
      <XACT> = ORIGINAL.
      MODIFY EXTRACT INDEX SY-TABIX.
    ENDIF.
    <ACTION> = ORIGINAL.
    MODIFY TOTAL.
  ENDCASE.
ENDLOOP.
CLEAR: STATUS_YDDG_CONFIG___MV-UPD_FLAG,
STATUS_YDDG_CONFIG___MV-UPD_CHECKD.
MESSAGE S018(SV).
ENDFORM.
*---------------------------------------------------------------------*
FORM READ_SINGLE_YDDG_CONFIG___MV.
  SELECT SINGLE * FROM YDDG_CONFIG WHERE
HANDLE = YDDG_CONFIG___MV-HANDLE .
YDDG_CONFIG___MV-HANDLE =
YDDG_CONFIG-HANDLE .
YDDG_CONFIG___MV-VALUE =
YDDG_CONFIG-VALUE .
ENDFORM.
*---------------------------------------------------------------------*
FORM CORR_MAINT_YDDG_CONFIG___MV USING VALUE(CM_ACTION) RC.
  DATA: RETCODE LIKE SY-SUBRC, COUNT TYPE I, TRSP_KEYLEN TYPE SYFLENG.
  FIELD-SYMBOLS: <TAB_KEY_X> TYPE X.
  CLEAR RC.
MOVE YDDG_CONFIG___MV-HANDLE TO
YDDG_CONFIG-HANDLE .
  CORR_KEYTAB             =  E071K.
  CORR_KEYTAB-OBJNAME     = 'YDDG_CONFIG'.
  IF NOT <vim_corr_keyx> IS ASSIGNED.
    ASSIGN CORR_KEYTAB-TABKEY TO <vim_corr_keyx> CASTING.
  ENDIF.
  ASSIGN YDDG_CONFIG TO <TAB_KEY_X> CASTING.
  PERFORM VIM_GET_TRSPKEYLEN
    USING 'YDDG_CONFIG'
    CHANGING TRSP_KEYLEN.
  <VIM_CORR_KEYX>(TRSP_KEYLEN) = <TAB_KEY_X>(TRSP_KEYLEN).
  PERFORM UPDATE_CORR_KEYTAB USING CM_ACTION RETCODE.
  ADD: RETCODE TO RC, 1 TO COUNT.
  IF RC LT COUNT AND CM_ACTION NE PRUEFEN.
    CLEAR RC.
  ENDIF.

ENDFORM.
*---------------------------------------------------------------------*
*...processing: YDDG_GLBL_TAG_MV................................*
FORM GET_DATA_YDDG_GLBL_TAG_MV.
  PERFORM VIM_FILL_WHERETAB.
*.read data from database.............................................*
  REFRESH TOTAL.
  CLEAR   TOTAL.
  SELECT * FROM YDDG_GLOBAL_TAGS WHERE
(VIM_WHERETAB) .
    CLEAR YDDG_GLBL_TAG_MV .
YDDG_GLBL_TAG_MV-TAG =
YDDG_GLOBAL_TAGS-TAG .
<VIM_TOTAL_STRUC> = YDDG_GLBL_TAG_MV.
    APPEND TOTAL.
  ENDSELECT.
  SORT TOTAL BY <VIM_XTOTAL_KEY>.
  <STATUS>-ALR_SORTED = 'R'.
*.check dynamic selectoptions (not in DDIC)...........................*
  IF X_HEADER-SELECTION NE SPACE.
    PERFORM CHECK_DYNAMIC_SELECT_OPTIONS.
  ELSEIF X_HEADER-DELMDTFLAG NE SPACE.
    PERFORM BUILD_MAINKEY_TAB.
  ENDIF.
  REFRESH EXTRACT.
ENDFORM.
*---------------------------------------------------------------------*
FORM DB_UPD_YDDG_GLBL_TAG_MV .
*.process data base updates/inserts/deletes.........................*
LOOP AT TOTAL.
  CHECK <ACTION> NE ORIGINAL.
MOVE <VIM_TOTAL_STRUC> TO YDDG_GLBL_TAG_MV.
  IF <ACTION> = UPDATE_GELOESCHT.
    <ACTION> = GELOESCHT.
  ENDIF.
  CASE <ACTION>.
   WHEN NEUER_GELOESCHT.
IF STATUS_YDDG_GLBL_TAG_MV-ST_DELETE EQ GELOESCHT.
     READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY>.
     IF SY-SUBRC EQ 0.
       DELETE EXTRACT INDEX SY-TABIX.
     ENDIF.
    ENDIF.
    DELETE TOTAL.
    IF X_HEADER-DELMDTFLAG NE SPACE.
      PERFORM DELETE_FROM_MAINKEY_TAB.
    ENDIF.
   WHEN GELOESCHT.
  SELECT SINGLE FOR UPDATE * FROM YDDG_GLOBAL_TAGS WHERE
  TAG = YDDG_GLBL_TAG_MV-TAG .
    IF SY-SUBRC = 0.
    DELETE YDDG_GLOBAL_TAGS .
    ENDIF.
    IF STATUS-DELETE EQ GELOESCHT.
      READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY> BINARY SEARCH.
      DELETE EXTRACT INDEX SY-TABIX.
    ENDIF.
    DELETE TOTAL.
    IF X_HEADER-DELMDTFLAG NE SPACE.
      PERFORM DELETE_FROM_MAINKEY_TAB.
    ENDIF.
   WHEN OTHERS.
  SELECT SINGLE FOR UPDATE * FROM YDDG_GLOBAL_TAGS WHERE
  TAG = YDDG_GLBL_TAG_MV-TAG .
    IF SY-SUBRC <> 0.   "insert preprocessing: init WA
      CLEAR YDDG_GLOBAL_TAGS.
    ENDIF.
YDDG_GLOBAL_TAGS-TAG =
YDDG_GLBL_TAG_MV-TAG .
    IF SY-SUBRC = 0.
    UPDATE YDDG_GLOBAL_TAGS ##WARN_OK.
    ELSE.
    INSERT YDDG_GLOBAL_TAGS .
    ENDIF.
    READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY>.
    IF SY-SUBRC EQ 0.
      <XACT> = ORIGINAL.
      MODIFY EXTRACT INDEX SY-TABIX.
    ENDIF.
    <ACTION> = ORIGINAL.
    MODIFY TOTAL.
  ENDCASE.
ENDLOOP.
CLEAR: STATUS_YDDG_GLBL_TAG_MV-UPD_FLAG,
STATUS_YDDG_GLBL_TAG_MV-UPD_CHECKD.
MESSAGE S018(SV).
ENDFORM.
*---------------------------------------------------------------------*
FORM READ_SINGLE_YDDG_GLBL_TAG_MV.
  SELECT SINGLE * FROM YDDG_GLOBAL_TAGS WHERE
TAG = YDDG_GLBL_TAG_MV-TAG .
YDDG_GLBL_TAG_MV-TAG =
YDDG_GLOBAL_TAGS-TAG .
ENDFORM.
*---------------------------------------------------------------------*
FORM CORR_MAINT_YDDG_GLBL_TAG_MV USING VALUE(CM_ACTION) RC.
  DATA: RETCODE LIKE SY-SUBRC, COUNT TYPE I, TRSP_KEYLEN TYPE SYFLENG.
  FIELD-SYMBOLS: <TAB_KEY_X> TYPE X.
  CLEAR RC.
MOVE YDDG_GLBL_TAG_MV-TAG TO
YDDG_GLOBAL_TAGS-TAG .
  CORR_KEYTAB             =  E071K.
  CORR_KEYTAB-OBJNAME     = 'YDDG_GLOBAL_TAGS'.
  IF NOT <vim_corr_keyx> IS ASSIGNED.
    ASSIGN CORR_KEYTAB-TABKEY TO <vim_corr_keyx> CASTING.
  ENDIF.
  ASSIGN YDDG_GLOBAL_TAGS TO <TAB_KEY_X> CASTING.
  PERFORM VIM_GET_TRSPKEYLEN
    USING 'YDDG_GLOBAL_TAGS'
    CHANGING TRSP_KEYLEN.
  <VIM_CORR_KEYX>(TRSP_KEYLEN) = <TAB_KEY_X>(TRSP_KEYLEN).
  PERFORM UPDATE_CORR_KEYTAB USING CM_ACTION RETCODE.
  ADD: RETCODE TO RC, 1 TO COUNT.
  IF RC LT COUNT AND CM_ACTION NE PRUEFEN.
    CLEAR RC.
  ENDIF.

ENDFORM.
*---------------------------------------------------------------------*
*...processing: YDDG_METRICS__MV................................*
FORM GET_DATA_YDDG_METRICS__MV.
  PERFORM VIM_FILL_WHERETAB.
*.read data from database.............................................*
  REFRESH TOTAL.
  CLEAR   TOTAL.
  SELECT * FROM YDDG_METRICS WHERE
(VIM_WHERETAB) .
    CLEAR YDDG_METRICS__MV .
YDDG_METRICS__MV-HANDLE =
YDDG_METRICS-HANDLE .
YDDG_METRICS__MV-METRIC_TYPE =
YDDG_METRICS-METRIC_TYPE .
YDDG_METRICS__MV-NAME =
YDDG_METRICS-NAME .
<VIM_TOTAL_STRUC> = YDDG_METRICS__MV.
    APPEND TOTAL.
  ENDSELECT.
  SORT TOTAL BY <VIM_XTOTAL_KEY>.
  <STATUS>-ALR_SORTED = 'R'.
*.check dynamic selectoptions (not in DDIC)...........................*
  IF X_HEADER-SELECTION NE SPACE.
    PERFORM CHECK_DYNAMIC_SELECT_OPTIONS.
  ELSEIF X_HEADER-DELMDTFLAG NE SPACE.
    PERFORM BUILD_MAINKEY_TAB.
  ENDIF.
  REFRESH EXTRACT.
ENDFORM.
*---------------------------------------------------------------------*
FORM DB_UPD_YDDG_METRICS__MV .
*.process data base updates/inserts/deletes.........................*
LOOP AT TOTAL.
  CHECK <ACTION> NE ORIGINAL.
MOVE <VIM_TOTAL_STRUC> TO YDDG_METRICS__MV.
  IF <ACTION> = UPDATE_GELOESCHT.
    <ACTION> = GELOESCHT.
  ENDIF.
  CASE <ACTION>.
   WHEN NEUER_GELOESCHT.
IF STATUS_YDDG_METRICS__MV-ST_DELETE EQ GELOESCHT.
     READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY>.
     IF SY-SUBRC EQ 0.
       DELETE EXTRACT INDEX SY-TABIX.
     ENDIF.
    ENDIF.
    DELETE TOTAL.
    IF X_HEADER-DELMDTFLAG NE SPACE.
      PERFORM DELETE_FROM_MAINKEY_TAB.
    ENDIF.
   WHEN GELOESCHT.
  SELECT SINGLE FOR UPDATE * FROM YDDG_METRICS WHERE
  HANDLE = YDDG_METRICS__MV-HANDLE .
    IF SY-SUBRC = 0.
    DELETE YDDG_METRICS .
    ENDIF.
    IF STATUS-DELETE EQ GELOESCHT.
      READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY> BINARY SEARCH.
      DELETE EXTRACT INDEX SY-TABIX.
    ENDIF.
    DELETE TOTAL.
    IF X_HEADER-DELMDTFLAG NE SPACE.
      PERFORM DELETE_FROM_MAINKEY_TAB.
    ENDIF.
   WHEN OTHERS.
  SELECT SINGLE FOR UPDATE * FROM YDDG_METRICS WHERE
  HANDLE = YDDG_METRICS__MV-HANDLE .
    IF SY-SUBRC <> 0.   "insert preprocessing: init WA
      CLEAR YDDG_METRICS.
    ENDIF.
YDDG_METRICS-HANDLE =
YDDG_METRICS__MV-HANDLE .
YDDG_METRICS-METRIC_TYPE =
YDDG_METRICS__MV-METRIC_TYPE .
YDDG_METRICS-NAME =
YDDG_METRICS__MV-NAME .
    IF SY-SUBRC = 0.
    UPDATE YDDG_METRICS ##WARN_OK.
    ELSE.
    INSERT YDDG_METRICS .
    ENDIF.
    READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY>.
    IF SY-SUBRC EQ 0.
      <XACT> = ORIGINAL.
      MODIFY EXTRACT INDEX SY-TABIX.
    ENDIF.
    <ACTION> = ORIGINAL.
    MODIFY TOTAL.
  ENDCASE.
ENDLOOP.
CLEAR: STATUS_YDDG_METRICS__MV-UPD_FLAG,
STATUS_YDDG_METRICS__MV-UPD_CHECKD.
MESSAGE S018(SV).
ENDFORM.
*---------------------------------------------------------------------*
FORM READ_SINGLE_YDDG_METRICS__MV.
  SELECT SINGLE * FROM YDDG_METRICS WHERE
HANDLE = YDDG_METRICS__MV-HANDLE .
YDDG_METRICS__MV-HANDLE =
YDDG_METRICS-HANDLE .
YDDG_METRICS__MV-METRIC_TYPE =
YDDG_METRICS-METRIC_TYPE .
YDDG_METRICS__MV-NAME =
YDDG_METRICS-NAME .
ENDFORM.
*---------------------------------------------------------------------*
FORM CORR_MAINT_YDDG_METRICS__MV USING VALUE(CM_ACTION) RC.
  DATA: RETCODE LIKE SY-SUBRC, COUNT TYPE I, TRSP_KEYLEN TYPE SYFLENG.
  FIELD-SYMBOLS: <TAB_KEY_X> TYPE X.
  CLEAR RC.
MOVE YDDG_METRICS__MV-HANDLE TO
YDDG_METRICS-HANDLE .
  CORR_KEYTAB             =  E071K.
  CORR_KEYTAB-OBJNAME     = 'YDDG_METRICS'.
  IF NOT <vim_corr_keyx> IS ASSIGNED.
    ASSIGN CORR_KEYTAB-TABKEY TO <vim_corr_keyx> CASTING.
  ENDIF.
  ASSIGN YDDG_METRICS TO <TAB_KEY_X> CASTING.
  PERFORM VIM_GET_TRSPKEYLEN
    USING 'YDDG_METRICS'
    CHANGING TRSP_KEYLEN.
  <VIM_CORR_KEYX>(TRSP_KEYLEN) = <TAB_KEY_X>(TRSP_KEYLEN).
  PERFORM UPDATE_CORR_KEYTAB USING CM_ACTION RETCODE.
  ADD: RETCODE TO RC, 1 TO COUNT.
  IF RC LT COUNT AND CM_ACTION NE PRUEFEN.
    CLEAR RC.
  ENDIF.

ENDFORM.
*---------------------------------------------------------------------*
*...processing: YDDG_TAGS_____MV................................*
FORM GET_DATA_YDDG_TAGS_____MV.
  PERFORM VIM_FILL_WHERETAB.
*.read data from database.............................................*
  REFRESH TOTAL.
  CLEAR   TOTAL.
  SELECT * FROM YDDG_TAGS WHERE
(VIM_WHERETAB) .
    CLEAR YDDG_TAGS_____MV .
YDDG_TAGS_____MV-HANDLE =
YDDG_TAGS-HANDLE .
YDDG_TAGS_____MV-TAG =
YDDG_TAGS-TAG .
YDDG_TAGS_____MV-ANONYMIZE =
YDDG_TAGS-ANONYMIZE .
<VIM_TOTAL_STRUC> = YDDG_TAGS_____MV.
    APPEND TOTAL.
  ENDSELECT.
  SORT TOTAL BY <VIM_XTOTAL_KEY>.
  <STATUS>-ALR_SORTED = 'R'.
*.check dynamic selectoptions (not in DDIC)...........................*
  IF X_HEADER-SELECTION NE SPACE.
    PERFORM CHECK_DYNAMIC_SELECT_OPTIONS.
  ELSEIF X_HEADER-DELMDTFLAG NE SPACE.
    PERFORM BUILD_MAINKEY_TAB.
  ENDIF.
  REFRESH EXTRACT.
ENDFORM.
*---------------------------------------------------------------------*
FORM DB_UPD_YDDG_TAGS_____MV .
*.process data base updates/inserts/deletes.........................*
LOOP AT TOTAL.
  CHECK <ACTION> NE ORIGINAL.
MOVE <VIM_TOTAL_STRUC> TO YDDG_TAGS_____MV.
  IF <ACTION> = UPDATE_GELOESCHT.
    <ACTION> = GELOESCHT.
  ENDIF.
  CASE <ACTION>.
   WHEN NEUER_GELOESCHT.
IF STATUS_YDDG_TAGS_____MV-ST_DELETE EQ GELOESCHT.
     READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY>.
     IF SY-SUBRC EQ 0.
       DELETE EXTRACT INDEX SY-TABIX.
     ENDIF.
    ENDIF.
    DELETE TOTAL.
    IF X_HEADER-DELMDTFLAG NE SPACE.
      PERFORM DELETE_FROM_MAINKEY_TAB.
    ENDIF.
   WHEN GELOESCHT.
  SELECT SINGLE FOR UPDATE * FROM YDDG_TAGS WHERE
  HANDLE = YDDG_TAGS_____MV-HANDLE .
    IF SY-SUBRC = 0.
    DELETE YDDG_TAGS .
    ENDIF.
    IF STATUS-DELETE EQ GELOESCHT.
      READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY> BINARY SEARCH.
      DELETE EXTRACT INDEX SY-TABIX.
    ENDIF.
    DELETE TOTAL.
    IF X_HEADER-DELMDTFLAG NE SPACE.
      PERFORM DELETE_FROM_MAINKEY_TAB.
    ENDIF.
   WHEN OTHERS.
  SELECT SINGLE FOR UPDATE * FROM YDDG_TAGS WHERE
  HANDLE = YDDG_TAGS_____MV-HANDLE .
    IF SY-SUBRC <> 0.   "insert preprocessing: init WA
      CLEAR YDDG_TAGS.
    ENDIF.
YDDG_TAGS-HANDLE =
YDDG_TAGS_____MV-HANDLE .
YDDG_TAGS-TAG =
YDDG_TAGS_____MV-TAG .
YDDG_TAGS-ANONYMIZE =
YDDG_TAGS_____MV-ANONYMIZE .
    IF SY-SUBRC = 0.
    UPDATE YDDG_TAGS ##WARN_OK.
    ELSE.
    INSERT YDDG_TAGS .
    ENDIF.
    READ TABLE EXTRACT WITH KEY <VIM_XTOTAL_KEY>.
    IF SY-SUBRC EQ 0.
      <XACT> = ORIGINAL.
      MODIFY EXTRACT INDEX SY-TABIX.
    ENDIF.
    <ACTION> = ORIGINAL.
    MODIFY TOTAL.
  ENDCASE.
ENDLOOP.
CLEAR: STATUS_YDDG_TAGS_____MV-UPD_FLAG,
STATUS_YDDG_TAGS_____MV-UPD_CHECKD.
MESSAGE S018(SV).
ENDFORM.
*---------------------------------------------------------------------*
FORM READ_SINGLE_YDDG_TAGS_____MV.
  SELECT SINGLE * FROM YDDG_TAGS WHERE
HANDLE = YDDG_TAGS_____MV-HANDLE .
YDDG_TAGS_____MV-HANDLE =
YDDG_TAGS-HANDLE .
YDDG_TAGS_____MV-TAG =
YDDG_TAGS-TAG .
YDDG_TAGS_____MV-ANONYMIZE =
YDDG_TAGS-ANONYMIZE .
ENDFORM.
*---------------------------------------------------------------------*
FORM CORR_MAINT_YDDG_TAGS_____MV USING VALUE(CM_ACTION) RC.
  DATA: RETCODE LIKE SY-SUBRC, COUNT TYPE I, TRSP_KEYLEN TYPE SYFLENG.
  FIELD-SYMBOLS: <TAB_KEY_X> TYPE X.
  CLEAR RC.
MOVE YDDG_TAGS_____MV-HANDLE TO
YDDG_TAGS-HANDLE .
  CORR_KEYTAB             =  E071K.
  CORR_KEYTAB-OBJNAME     = 'YDDG_TAGS'.
  IF NOT <vim_corr_keyx> IS ASSIGNED.
    ASSIGN CORR_KEYTAB-TABKEY TO <vim_corr_keyx> CASTING.
  ENDIF.
  ASSIGN YDDG_TAGS TO <TAB_KEY_X> CASTING.
  PERFORM VIM_GET_TRSPKEYLEN
    USING 'YDDG_TAGS'
    CHANGING TRSP_KEYLEN.
  <VIM_CORR_KEYX>(TRSP_KEYLEN) = <TAB_KEY_X>(TRSP_KEYLEN).
  PERFORM UPDATE_CORR_KEYTAB USING CM_ACTION RETCODE.
  ADD: RETCODE TO RC, 1 TO COUNT.
  IF RC LT COUNT AND CM_ACTION NE PRUEFEN.
    CLEAR RC.
  ENDIF.

ENDFORM.
*---------------------------------------------------------------------*
